(* This file was generated by Ocsigen Start.
   Feel free to use it, modify it, and redistribute it as you wish. *)

(* PGOcaml demo *)

[%%shared
  open Eliom_content.Html.F
]

(* Service for this demo *)
let%server service =
  Eliom_service.create
    ~path:(Eliom_service.Path ["demo-pgocaml"])
    ~meth:(Eliom_service.Get Eliom_parameter.unit)
    ()

(* Make service available on the client *)
let%client service = ~%service

(* Name for demo menu *)
let%shared name = "Database request"

(* Class for the page containing this demo (for internal use) *)
let%shared page_class = "os-page-demo-pgocaml"

(* Fetch users in database *)
let%server get_users () =
  (* For this demo, we add a delay to simulate a network or db latency: *)
  let%lwt () = Lwt_unix.sleep 2. in
  Demo_pgocaml_db.get ()

(* Make function get_users available to the client *)
let%client get_users =
  ~%(Eliom_client.server_function [%derive.json: unit] get_users)

(* Generate page for this demo *)
let%shared page () =
  let%lwt user_block =
    Ot_spinner.with_spinner
      (let%lwt users = get_users () in
       let users = List.map (fun u -> li [pcdata u]) users in
       if users = []
       then Lwt.return
           [ p [ em [ pcdata "No user. Create some accounts to test." ]] ]
       else Lwt.return [ p [ pcdata "Users:" ]
                       ; ul users ])
  in
  Lwt.return [ p [pcdata "This page shows signed-up users fetched from the \
                          database."]
             ; p [pcdata "Have a look at the source code to see how to \
                          make a DB request with PGOCaml."]
             ; p [pcdata "We are using Ot_spinner to display the list, \
                          which means that, in the case the page is generated \
                          client-side, the page will be displayed immediately \
                          with a spinner, that will be replaced by the \
                          contents when ready. The code contains a 2s sleep \
                          to demonstrate the spinner."]
             ; user_block ]
